import javax.xml.parsers.*;

import org.xml.sax.*; 
import org.xml.sax.helpers.*; 

import java.io.*;
import org.w3c.dom.*;

public class DocumentRoot extends DefaultHandler {
   static Document document;

   public static void main(String argv[])
   {
      if (argv.length != 1) {
         System.err.println("Usage: Java DocumentRoot xmlfilename");
         System.exit(1);
      }

      try {
           DocumentBuilderFactory factory =
              DocumentBuilderFactory.newInstance();

         DocumentBuilder builder = factory.newDocumentBuilder();

         //   Set Error Handler
         builder.setErrorHandler(new DocumentRoot());
           document = builder.parse(new File(argv[0]));
         System.out.println("Number of children of the document root ==> " +
            document.getChildNodes().getLength());

         NodeList nodes = document.getChildNodes();
         for (int i=0; i<nodes.getLength() ; i++)
         {   System.out.println("Child " + i + " type " + nodes.item(i).getNodeType() + " => " + nodes.item(i));
         }
       } catch (Throwable e) {

        e.printStackTrace();
      }
   } // main
}